## pakcs 2.0.1

=== Makefile ===
#****************************************************************************
# PAKCS: The Portland Aachen Kiel Curry System
# ============================================
#
# A Prolog-based implementation of the functional logic language Curry
# developed by
#
# Sergio Antoy, Bernd Brassel, Martin Engelke, Michael Hanus, Klaus Hoeppner,
# Johannes Koj, Philipp Niederau, Ramin Sadre, Frank Steiner
#
# (contact: pakcs@curry-language.org)
#****************************************************************************

# Some parameters for this installation
# --------------------------------------
# (these parameters might be passed to `make`)

# If the parameter CURRYFRONTEND is set to an executable,
# this executable will be used as the front end for PAKCS.
# Otherwise, the front end will be compiled from the sources
# in subdir "frontend" (if it exists).
export CURRYFRONTEND =

# Is this an installation for a distribution (Debian) package (yes|no)?
# In case of "yes":
# - nothing will be stored during the installation in the home directory
# - the documentation will not be built (since this takes a lot of time)
# - the paramters CURRYLIBSDIR and CURRYTOOLSDIR must be defined and
#   refer to the directories containing the Curry system libraries and tools
export DISTPKGINSTALL = no

# In order to build the system in a place different from the place of
# the final installation (e.g., when building it as a (Debian) package),
# the variable PAKCSINSTALLDIR should be set to the location where it
# will be finally installed after the build (e.g., /usr/lib/pakcs).
# It is required that during the build, this directory does not exist,
# otherwise the build fails. If this variable is set and the
# installed system will be moved to this location after the build, it will be
# used as the root directory for all generated components of the system.
export PAKCSINSTALLDIR =

########################################################################
# The name of the Curry system, needed for the installation of
# the system libraries and tools:
export CURRYSYSTEM=pakcs

# The major version number:
export MAJORVERSION=2
# The minor version number:
export MINORVERSION=0
# The revision version number:
REVISIONVERSION=1
# The build version number (if >0, then it is a pre-release)
BUILDVERSION=0
# Complete version:
VERSION=$(MAJORVERSION).$(MINORVERSION).$(REVISIONVERSION)
# The version date:
ifeq ($(DISTPKGINSTALL),yes)
COMPILERDATE := $(shell date "+%Y-%m-%d")
else
COMPILERDATE := $(shell git log -1 --format="%ci" | cut -c-10)
endif

# Paths used in this installation
# -------------------------------

# the root directory of the installation
export ROOT=$(CURDIR)

# Directories of the sources of the standard libraries and tools
ifeq ($(DISTPKGINSTALL),yes)
export CURRYLIBSDIR  = $(error "CURRYLIBSDIR is undefined!")
export CURRYTOOLSDIR = $(error "CURRYTOOLSDIR is undefined!")
else
export CURRYLIBSDIR  = $(ROOT)/lib-trunk
export CURRYTOOLSDIR = # not used
endif

# binary directory and executables
export BINDIR=$(ROOT)/bin
# Directory where the front end is located
export FRONTENDDIR   = $(ROOT)/frontend
# Directory where the actual libraries are located
export LIBDIR        = $(ROOT)/lib
# Directory where the documentation files are located
export DOCDIR        = $(ROOT)/docs

# The file containing the version number of the base libraries:
BASEVERSIONFILE = $(LIBDIR)/VERSION

# Executable of CurryCheck:
CURRYCHECK := $(shell which curry-check)
# Executable of CurryDoc:
CURRYDOC := $(shell which curry-doc)
# Executable of the markdown translator (required for documentation generation):
MD2PDF := $(shell which md2pdf)

# The version information file for PAKCS:
PAKCSVERSION=$(ROOT)/src/pakcsversion.pl
# The version information file for the manual:
MANUALVERSION=$(DOCDIR)/src/version.tex

# Various executables used in the installation
# --------------------------------------------

# The REPL binary, used for building various tools
export REPL         = $(BINDIR)/$(CURRYSYSTEM)
# The default options for the REPL
export REPL_OPTS    = --noreadline :set -time
# The front end binary
export CYMAKE       = $(BINDIR)/$(CURRYSYSTEM)-frontend
# The cleancurry binary
export CLEANCURRY   = $(BINDIR)/cleancurry

# Logfile for make:
MAKELOG=make.log

########################################################################
# The targets
########################################################################

#
# Install all components of PAKCS
#
.PHONY: all
all:
ifeq ($(DISTPKGINSTALL),yes)
	$(MAKE) config
	$(MAKE) build
	# if we build a package, we compile all libraries at the end
	# so that their intermediate files are up to date:
	$(REPL) --nocypm $(REPL_OPTS) :load AllLibraries :eval "3*13+3" :quit
else
	@rm -f $(MAKELOG)
	@echo "Make started at `date`" > $(MAKELOG)
	$(MAKE) config 2>&1 | tee -a $(MAKELOG)
	$(MAKE) build  2>&1 | tee -a $(MAKELOG)
	@echo "Make finished at `date`" >> $(MAKELOG)
	@echo "Make process logged in file $(MAKELOG)"
endif

# Check whether the value of PAKCSINSTALLDIR, if defined, is a non-existing
# directory
.PHONY: checkinstalldir
checkinstalldir:
	@if [ -n "$(PAKCSINSTALLDIR)" -a -d "$(PAKCSINSTALLDIR)" ] ; then \
	  echo "ERROR: Variable PAKCSINSTALLDIR points to an existing directory!" && exit 1 ; \
	fi

#
# Build all components of PAKCS
#
.PHONY: build
build: checkinstalldir
	$(MAKE) kernel
	$(MAKE) tools
	$(MAKE) manual
	chmod -R go+rX .

# install the kernel system (binaries and libraries)
.PHONY: kernel
kernel: scripts copylibs copytools
	@echo "PAKCS installation configuration (file pakcsinitrc):"
	@cat pakcsinitrc
	# install front end:
	$(MAKE) frontend
	# pre-compile all libraries:
	@cd lib && $(MAKE) fcy
	# build the PAKCS compiler as a saved system:
	$(MAKE) $(PAKCSVERSION)
	cd src && $(MAKE)
	# compile all libraries:
	@cd lib && $(MAKE) acy
	# compile optimization tools:
	@cd currytools/optimize && $(MAKE)
	# prepare for separate compilation: compile all libraries to Prolog
	@if [ -r bin/pakcs ] ; then cd lib && $(MAKE) pl ; fi

# Clean old files that might be in conflict with newer versions of PAKCS:
.PHONY: cleanoldinfos
cleanoldinfos:
	# delete old RequiredValue analysis files since format has changed:
	@if [ -d $(HOME)/.curry/Analysis ] ; then \
	  find $(HOME)/.curry/Analysis -name \*.RequiredValue.p\* -exec rm -f \{\} \; ; fi

# Configure installation w.r.t. variables in pakcsinitrc:
.PHONY: config
config: scripts
	@scripts/configure-pakcs

# install the scripts of PAKCS in the bin directory:
.PHONY: scripts
scripts:
	cd scripts && $(MAKE) all

# remove the scripts of PAKCS in the bin directory:
.PHONY: cleanscripts
cleanscripts:
	cd scripts && $(MAKE) clean

# install the library sources from the trunk directory:
.PHONY: copylibs
copylibs:
	@if [ -d $(CURRYLIBSDIR) ] ; then cd $(CURRYLIBSDIR) && $(MAKE) -f Makefile_$(CURRYSYSTEM)_install ; fi

# if the directory `currytools` is not present, copy it from the sources:
# (only necessary for the installation of a (Debian) packages, otherwise
# `currytools` is a submodule of the repository)
.PHONY: copytools
copytools:
ifeq ($(DISTPKGINSTALL),yes)
	@if [ ! -f currytools/Makefile ] ; then $(MAKE) forcecopytools ; fi
endif

.PHONY: forcecopytools
forcecopytools:
	mkdir -p currytools
	# Copying currytools from $(CURRYTOOLSDIR)
	cp -pr $(CURRYTOOLSDIR)/* currytools

# install front end (from environment variable or sources):
.PHONY: frontend
frontend:
ifeq ($(shell test -x "$(CURRYFRONTEND)" ; echo $$?),0)
	rm -f $(CYMAKE)
	ln -s $(CURRYFRONTEND) $(CYMAKE)
else
	@if [ -d $(FRONTENDDIR) ] ; then $(MAKE) compilefrontend ; fi
endif

.PHONY: compilefrontend
compilefrontend:
	rm -f $(CYMAKE)
	cd $(FRONTENDDIR) && $(MAKE)
	cd $(BINDIR) && ln -s ../frontend/bin/curry-frontend $(notdir $(CYMAKE))

# compile the tools:
.PHONY: tools
tools:
	@if [ -r bin/pakcs ] ; then cd currytools && $(MAKE) ; fi
	@if [ -r bin/pakcs ] ; then cd tools      && $(MAKE) ; fi

# compile analysis tool only:
.PHONY: CASS
CASS:
	@if [ -r bin/pakcs ] ; then cd currytools && $(MAKE) CASS ; fi

# compile documentation if sources are available and it is not a
# separate package distribution:
.PHONY: manual
manual:
	@if [ -d $(DOCDIR)/src -a $(DISTPKGINSTALL) = "no" ] ; then \
	   if [ -x "$(CURRYDOC)" -a -x "$(MD2PDF)" ] ; then \
	     $(MAKE) $(MANUALVERSION) && cd $(DOCDIR)/src && $(MAKE) install ; \
	   else echo "Executable 'curry-doc' or 'md2pdf' not found!" ; \
	        echo "To generate the manual, install them by:" ; \
                echo "> cypm install currydoc && cypm install markdown" ; \
           fi \
         fi

# Create file with version information for PAKCS:
$(PAKCSVERSION): Makefile $(BASEVERSIONFILE)
	echo ':- module(pakcsversion,[compilerVersion/1, compilerMajorVersion/1, compilerMinorVersion/1, compilerRevisionVersion/1, buildVersion/1, buildDate/1, buildDir/1, pkgInstallDir/1, baseVersion/1]).' > $@
	echo "compilerVersion('PAKCS$(MAJORVERSION).$(MINORVERSION)')." >> $@
	echo 'compilerMajorVersion($(MAJORVERSION)).' >> $@
	echo 'compilerMinorVersion($(MINORVERSION)).' >> $@
	echo 'compilerRevisionVersion($(REVISIONVERSION)).' >> $@
	echo 'buildVersion($(BUILDVERSION)).' >> $@
	echo "buildDate('$(COMPILERDATE)')." >> $@
	echo "buildDir('$(ROOT)')." >> $@
	echo "pkgInstallDir('$(PAKCSINSTALLDIR)')." >> $@
	echo "baseVersion('$(shell cat $(BASEVERSIONFILE))')." >> $@

# Create file with version information for the manual:
$(MANUALVERSION): Makefile
	echo '\\newcommand{\\pakcsversion}{$(VERSION)}' > $@
	echo '\\newcommand{\\pakcsversiondate}{Version of $(COMPILERDATE)}' >> $@

#
# Create documentation for system libraries:
#
.PHONY: libdoc
libdoc:
	@if [ ! -x "$(CURRYDOC)" ] ; then \
	  echo "Executable 'curry-doc' is not installed!" && echo "Install it by > cpm install currydoc" ; \
	else $(MAKE) genlibdoc ; \
	fi

.PHONY: genlibdoc
genlibdoc:
	@rm -f $(MAKELOG)
	@echo "Make libdoc started at `date`" > $(MAKELOG)
	@cd lib && $(MAKE) htmldoc 2>&1 | tee -a ../$(MAKELOG)
	@echo "Make libdoc finished at `date`" >> $(MAKELOG)
	@echo "Make libdoc process logged in file $(MAKELOG)"

########################################################################
# Testing: run test suites to check the installation
#
ifeq ($(DISTPKGINSTALL),yes)
# for a package installation, we run the tests in verbose mode:
export RUNTESTPARAMS=-v
else
export RUNTESTPARAMS=
endif

# run the test suites to check the installation
.PHONY: runtest
runtest:
	@if [ ! -x "$(CURRYCHECK)" ] ; then \
	  echo "Executable 'curry-check' is not installed!" && echo "To run the tests, install it by > cypm install currycheck" ; \
	else $(MAKE) runalltests ; fi

.PHONY: runalltests
runalltests: testsuite/test.sh
	cd testsuite && ./test.sh $(RUNTESTPARAMS)
	cd lib && ./test.sh $(RUNTESTPARAMS)
	cd currytools && $(MAKE) runtest
	# remove .curry (might contain analysis results if home is missing)
	rm -rf .curry

# run the test suites in verbose mode so that all output is shown:
.PHONY: runtestverbose
runtestverbose:
	$(MAKE) runtest RUNTESTPARAMS=-v

########################################################################
# Cleaning:
#

# Build the cleancurry script:
$(CLEANCURRY):
	cd scripts && $(MAKE) $@

# Clean the system files, i.e., remove the installed PAKCS components
# except for the front end
.PHONY: clean
clean: $(CLEANCURRY)
	rm -f $(MAKELOG)
	$(MAKE) cleantools
	if [ -d lib ] ; then cd lib && $(MAKE) clean ; fi
	cd examples && $(CLEANCURRY) -r
	if [ -d $(DOCDIR)/src ] ; then cd $(DOCDIR)/src && $(MAKE) clean ; fi
	cd bin && rm -f sicstusprolog swiprolog
	cd scripts && $(MAKE) clean
	if [ -d $(FRONTENDDIR) ] ; then cd $(FRONTENDDIR) && $(MAKE) clean ; fi

# Clean the generated PAKCS tools
.PHONY: cleantools
cleantools: $(CLEANCURRY)
	cd src && $(MAKE) clean
	cd currytools && $(MAKE) uninstall
	cd tools && $(MAKE) clean
	cd bin && rm -f pakcs

# Clean everything (including the front end)
.PHONY: cleanall
cleanall: clean
	rm -rf $(LIBDIR)

=== frontend/Makefile ===
##############################################################################
# Makefile for installing the Curry front end
##############################################################################

# the root directory of the installation
export ROOT=$(CURDIR)
# binary directory and executables
export BINDIR=$(ROOT)/bin
# The frontend binary
export CYMAKE = $(BINDIR)/curry-frontend

# GHC and CABAL configuration (for installing the front end)
# ----------------------------------------------------------
# The path to the Glasgow Haskell Compiler and Cabal
export GHC     := $(shell which ghc)
export GHC-PKG := $(shell dirname "$(GHC)")/ghc-pkg
export CABAL    = cabal

# Because of an API change in GHC 7.6,
# we need to distinguish GHC < 7.6 and GHC >= 7.6.
# GHC 7.6 renamed the option "package-conf" to "package-db".

# extract GHC version
ifdef GHC
GHC_MAJOR := $(shell "$(GHC)" --numeric-version | cut -d. -f1)
GHC_MINOR := $(shell "$(GHC)" --numeric-version | cut -d. -f2)
# Is the GHC version >= 7.6 ?
GHC_GEQ_76 = $(shell test $(GHC_MAJOR) -gt 7 -o \( $(GHC_MAJOR) -eq 7 \
              -a $(GHC_MINOR) -ge 6 \) ; echo $$?)
# package-db (>= 7.6) or package-conf (< 7.6)?
ifeq ($(GHC_GEQ_76),0)
GHC_PKG_OPT = package-db
else
GHC_PKG_OPT = package-conf
endif
endif

# Command to unregister a package
export GHC_UNREGISTER = "$(GHC-PKG)" unregister --$(GHC_PKG_OPT)="$(PKGDB)"
# Command to install missing packages using cabal
export CABAL_INSTALL  = "$(CABAL)" install --with-compiler="$(GHC)"       \
                        --with-hc-pkg="$(GHC-PKG)" --prefix="$(LOCALPKG)" \
                        --global --package-db="$(PKGDB)" -O2

# Directory where local package installations are stored
export LOCALPKG      = $(ROOT)/pkg
# The path to the package database
export PKGDB         = $(LOCALPKG)/pakcs.conf.d

##############################################################################
# Retrieve all Haskell modules as dependencies for the front end:
DEPS := $(shell find curry-base/src/ curry-frontend/src/ -type f)

# install front end (if sources are present):
.PHONY: frontend
frontend:
ifdef GHC
	$(MAKE) $(PKGDB)
	$(MAKE) $(CYMAKE)
else
	@echo "GHC missing, cannot build front end!"
	@exit 1
endif

# create package database
$(PKGDB):
	"$(GHC-PKG)" init $@
	$(CABAL) update

# install the sources of the front end from its repository
$(CYMAKE): $(DEPS)
	$(MAKE) unregister
	mkdir -p $(@D)
	cd curry-base     && $(CABAL_INSTALL)
	$(MAKE) transformers # see below
	cd curry-frontend && $(CABAL_INSTALL) --bindir=$(@D)

# Temporary workaround for https://github.com/haskell/cabal/issues/1855
# see also http://www.haskell.org/pipermail/cabal-devel/2014-May/009795.html
.PHONY: transformers
transformers:
	$(CABAL_INSTALL) transformers-compat -f transformers3

# unregister previous version to avoid cabal install failures
.PHONY: unregister
unregister:
	-$(GHC_UNREGISTER) curry-frontend
	-$(GHC_UNREGISTER) curry-base

.PHONY: clean
clean:
	cd curry-base     && $(CABAL) clean
	cd curry-frontend && $(CABAL) clean

.PHONY: cleanall
cleanall:
	cd curry-base     && rm -rf dist/
	cd curry-frontend && rm -rf dist/
	rm -rf $(LOCALPKG)
	rm -f $(CYMAKE)   && rm -rf bin

=== scripts/Makefile ===
##############################################################################
# Installation of PAKCS shell scripts
##############################################################################

# the scripts to be installed
BINS = $(BINDIR)/pakcs $(BINDIR)/pakcs-makecgi \
       $(BINDIR)/cleancurry \
       $(BINDIR)/pakcs-fcypp


.PHONY: all
all:
	@if [ ! -d $(BINDIR) ] ; then mkdir -p $(BINDIR) ; fi
	$(MAKE) $(BINS)

# install some script of PAKCS in the bin directory:
$(BINDIR)/%: %.sh
	mkdir -p $(@D)
	cat $< | sed "s|^PAKCSBUILDDIR=.*$$|PAKCSBUILDDIR=$(ROOT)|" | \
	 sed "s|^PAKCSINSTALLDIR=.*$$|PAKCSINSTALLDIR=$(PAKCSINSTALLDIR)|" > $@
	chmod 755 $@

.PHONY: clean
clean:
	rm -f $(BINS)

=== src/Makefile ===
########################################################################
# Makefile for the Curry->Prolog compiler system of PAKCS
########################################################################

# bin directory to store executables of PAKCS:
ifndef BINDIR
BINDIR = $(dir $(CURDIR))/bin
endif

# The SICStus Prolog interpreter:
SICSTUS=$(BINDIR)/sicstusprolog

# The SWI-Prolog interpreter:
SWI=$(BINDIR)/swiprolog

# Standard options for SWI-Prolog
SWIOPTIONS=-q -L0 -G0 -T0 -O

# library directory of PAKCS:
ifndef LIBDIR
LIBDIR = $(dir $(CURDIR))/lib
endif

# names of run-time libraries:
PRIMLIBSRC = `cd lib_src && echo *.pl`

.PHONY: install
install:
	$(MAKE) uninstall
	@if [ -x "$(SICSTUS)" ] ; then $(MAKE) sicstus ; elif [ -x "$(SWI)" ] ; then $(MAKE) swi ; else echo "No Prolog defined to generate Curry->Prolog compiler" ; exit 1 ; fi
	../scripts/makesavedstate c2p.state
	rm -f pakcs
	mv c2p.state pakcs
	cd $(BINDIR) && ln -s pakcs curry

.PHONY: uninstall
uninstall:
	rm -f $(BINDIR)/curry

# make everything if we have a SICStus-Prolog system:
.PHONY: sicstus
sicstus:
	$(MAKE) libsicstus
	echo "[sicstusbasics], generatePrologBasics." | "$(SICSTUS)"
	$(MAKE) c2p.state

# make everything if we have a SWI-Prolog system:
.PHONY: swi
swi:
	$(MAKE) libswi
	rm -f prologbasics.pl ; cp swibasics.pl prologbasics.pl
	$(MAKE) swi.state
	mv -f swi.state c2p.state

#
# generate a saved state of the Curry->Prolog Compiler System w.r.t. SICStus-Prolog
#
c2p.state: prologbasics.pl basics.pl version.pl loader.pl evaluator.pl c2p.pl \
	      compiler.pl external.pl readFlcFromFcy.pl \
	      lib_src/prim_readshowterm.pl \
	      readXml.pl $(LIBDIR)/.curry/Prelude.fcy
	echo "compile(c2p),c2p('$(LIBDIR)/Prelude'),compile('$(LIBDIR)/.curry/pakcs/Prelude'),loadAndCompile('$(LIBDIR)/.curry/pakcs/Prelude.pl',[],create),saveprog_entry('c2p.state',user:pakcsMain)." \
           | "$(SICSTUS)"

#
# generate a saved state of the Curry->Prolog Compiler System w.r.t. SWI-Prolog
#
swi.state: prologbasics.pl basics.pl version.pl loader.pl evaluator.pl c2p.pl \
	      compiler.pl external.pl readFlcFromFcy.pl \
	      lib_src/prim_readshowterm.pl \
	      readXml.pl $(LIBDIR)/.curry/Prelude.fcy
	echo "compile(c2p). c2p('$(LIBDIR)/Prelude'), compile('$(LIBDIR)/.curry/pakcs/Prelude'),loader:loadAndCompile('$(LIBDIR)/.curry/pakcs/Prelude.pl',[],create). saveprog_entry('swi.state',user:pakcsMain)." | "$(SWI)" $(SWIOPTIONS)

$(LIBDIR)/.curry/Prelude.fcy: $(LIBDIR)/Prelude.curry
	cd $(LIBDIR) && $(MAKE) .curry/Prelude.fcy

#
# generate correct versions of run-time libraries for SWI-Prolog
#
.PHONY: libswi
libswi:
	@mkdir -p libswi
	@for i in $(PRIMLIBSRC) ; do $(MAKE) libswi/$$i ; done

libswi/%.pl: lib_src/%.pl
	echo "[block2freeze]. transFile('$*.pl')." | "$(SWI)" $(SWIOPTIONS)

#
# generate correct versions of run-time libraries for SICStus-Prolog
#
.PHONY: libsicstus
libsicstus:
	@mkdir -p libsicstus
	@for i in $(PRIMLIBSRC) ; do $(MAKE) libsicstus/$$i ; done

libsicstus/%.pl: lib_src/%.pl
	echo "[sicstus_processing]. transFile('$*.pl')." | "$(SICSTUS)"

# clean up everything
.PHONY: clean
clean: uninstall
	rm -f c2p.state pakcs $(LIBDIR)/.curry/pakcs/Prelude.pl prologbasics.pl
	rm -f pakcsversion.pl
	rm -rf libswi/ libsicstus/

=== tools/Makefile ===
# generate various tools for handling Curry programs:

# Required:
# - installed Curry system

.PHONY: all
all:
	@cd Peval     ; $(MAKE)


.PHONY: clean
clean:
	$(CLEANCURRY)
	cd Peval          && $(MAKE) clean

=== docs/src/Makefile ===
# To format the user manual

PAKCS=../../bin/pakcs

# Executable of the markdown translator:
MD2PDF := $(shell which md2pdf)

.PHONY: pdf
pdf : manual.pdf

manual.pdf: $(wildcard *.tex lib/*.tex tooldocs/*/*.tex) \
	    markdown_syntax.tex
	pdflatex manual
	bibtex manual
	pdflatex manual
	makeindex manual.idx
	pdflatex manual

../Manual.pdf: manual.pdf
	thumbpdf manual
	pdflatex manual
	rm -f $@
	cp $< $@

markdown_syntax.tex: markdown_syntax.txt
	$(MD2PDF) --include --tex -o "$@" "$<"

../markdown_syntax.html: markdown_syntax.txt
	$(MD2PDF) -t "Markdown Syntax" --html -o "$@" "$<"

# format installation description as HTML page
../INSTALL.html: ../../INSTALL.txt
	$(MD2PDF) -t "PAKCS Installation Instructions" --html -o "$@" "$<"

# format repository installation description as HTML page
../GITINSTALL.html: ../../GITINSTALL.txt
	$(MD2PDF) -t "PAKCS Repository" --html -o "$@" "$<"

# format release notes as HTML page
../RELNOTES.html: ../../RELNOTES.txt
	$(MD2PDF) -t "PAKCS Release Notes" --html -o "$@" "$<"

# format Curry style guide as HTML page
../CurryStyleGuide.html: tooldocs/casc/curry-style-guide.md
	cd tooldocs/casc && $(MAKE)
	@if [ -f "tooldocs/casc/curry-style-guide.html" ] ; then cp tooldocs/casc/curry-style-guide.html $@ ; fi

# generate documentation for all libraries
.PHONY: libdoc
libdoc:
	@cd ../../lib && $(MAKE) texdoc

.PHONY: install
install:
	$(MAKE) ../markdown_syntax.html
	$(MAKE) ../INSTALL.html
	$(MAKE) ../GITINSTALL.html
	$(MAKE) ../RELNOTES.html
	$(MAKE) ../CurryStyleGuide.html
	$(MAKE) libdoc
	$(MAKE) ../Manual.pdf

.PHONY: clean
clean:
	rm -f markdown_syntax.tex ../markdown_syntax.html \
	           ../INSTALL.html ../GITINSTALL.html ../RELNOTES.html
	rm -f *.aux *.bbl *.blg *.idx *.ilg *.ind *.log *.out *.pdf *.toc *.tpt
	rm -rf lib
	rm -f ../Manual.pdf ../Manual.ps.gz thumb* version.tex

=== tools/Peval/Makefile ===
# generate executable of the partial evaluator:

# Required:
# - installed Curry system (REPL)

.PHONY: all
all:    peval

# generate executable for partial evaluator program:
peval: peval.curry Flat.curry Flat2Fcy.curry
	$(REPL) --nocypm $(REPL_OPTS) :load peval :save :quit

clean: 
	rm -f peval
	$(CLEANCURRY)
	rm -f *_pe.flc *_pe.pl	# delete generated peval files

=== docs/src/tooldocs/casc/Makefile ===
default: curry-style-guide.html

# Generate an HTML version of the style guide.
curry-style-guide.html: curry-style-guide.md style.html
ifeq ($(shell which pandoc > /dev/null ; echo $$?),0)
	pandoc -s -N --toc -H style.html -o $@ $<
else
	@echo "WARNING: pandoc not found, Curry style description not generated"
endif

=== debian/changelog ===
pakcs (2.0.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.1.3. No changes needed.
    + Adapt versioned B-Ds and Ds for curry-* packages.
  * debian/{control,compat}:
    + Bump to DH version level 10 (level 11 not yet supported by CDBS).
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 09 Feb 2018 12:19:23 +0100

pakcs (2.0.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump versioned B-Ds and Ds (curry-*) to typeclasses supporting versions.
    + Enforce swi-prolog(-nox) (>= 7.4) as B-D and D. Important: PAKCS needs
      the same SWI Prolog version at runtime as it had at build time.
    + Set Priority: to optional.
    + Clean-up white-space at EOL.
  * debian/pakcs.{install,links}:
    + Adapt to this upstream release.
  * debian/rules:
    + Don't clean-up /usr/lib/pakcs/currytools/peval/.gitignore at post-build.
      Does not exist since PAKCS 1.15.x anymore.
    + Set permissions a-x on pakcsinitrc.sh (to make lintian happy).
    + Drop many LICENSE files shipped via the curry-tools tarball.
  * debian/copyright:
    + Update copyright attributions.
  * debian/patches:
    + Rebase/update 2001_run-cleancurry-from-inside-debian-subfolder.patch.
    + Drop 0001-Regression-test-for-CHR-library-removed-since-it-is-.patch.
      Applied upstream.
  * debian/man/runcurry.1: White-space cleanup at EOL.
  * debian/bin/cleancurry:
    + Drop file, use upstream's always-up-to-date version instead of shipping
      our own copy.
  * lintian: Drop various not-needed lintian overrides.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 12 Dec 2017 13:29:27 +0100

=== debian/control ===
Source: pakcs
Section: devel
Priority: optional
Maintainer: Debian Curry Maintainers <pkg-curry-maintainers@lists.alioth.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Michael Hanus <mh@informatik.uni-kiel.de>,
Build-Depends: cdbs,
 debhelper (>= 10~),
 quilt,
 curry-frontend (>= 1.0.1~),
 curry-libs-source (>= 2.0.1~),
 curry-tools-source (>= 2.0.1~),
 swi-prolog-nox (>= 7.4),
 sqlite3,
 lockfile-progs,
Standards-Version: 4.1.3
Homepage: https://www-ps.informatik.uni-kiel.de/~pakcs/
Vcs-Browser: https://anonscm.debian.org/git/pkg-curry/pakcs.git
Vcs-Git: https://anonscm.debian.org/git/pkg-curry/pakcs.git

Package: pakcs
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 curry-frontend (>= 1.0.1~),
 libjs-prototype (>= 1.6),
 swi-prolog-nox (>= 7.4),
 lockfile-progs,
Recommends:
 sqlite3,
Suggests:
 tk
Description: Portland Aachen Kiel Curry Compiler
 PAKCS is an implementation of the multi-paradigm declarative language
 Curry jointly developed by the Portland State University, the Aachen
 University of Technology, and the University of Kiel. Although this is
 not a highly optimized implementation but based on a high-level
 compilation of Curry programs into Prolog programs, it is not a toy
 implementation: PAKCS has been used for a variety of applications so far
 (e.g., graphical programming environments, an object-oriented front-end
 for Curry, partial evaluators, database applications, HTML programming
 with dynamic web pages, prototyping embedded systems). The size of all
 current Curry applications implemented with PAKCS amounts to more than
 150,000 lines (or 8 mbytes) of program code.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

VERBOSE=1

DISTPKGINSTALL=yes
CURRYFRONTEND=/usr/bin/curry-frontend
CURRYLIBSDIR=$(CURDIR)/debian/build/curry-libs
CURRYTOOLSDIR=$(CURDIR)/debian/build/curry-tools
PAKCSINSTALLDIR=/usr/lib/pakcs

# Only run unit tests on 64bit architectures for the reason given below.
#
# Quoting... http://www.swi-prolog.org/pldoc/man?section=64bits
#
# First of all, SWI-Prolog's addressing of the Prolog stacks does not
# cover the whole address space due to the use of type tag bits and
# garbage collection flags. On 32-bit hardware the stacks are limited to
# 128 MB each. This tends to be too low for demanding applications on
# modern hardware. On 64-bit hardware the limit is 2^32 times higher,
# exceeding the addressing capabilities of today's CPUs and operating
# systems. This implies Prolog can be started with stack sizes that use
# the full capabilities of your hardware.

ifeq (,$(filter 32,$(DEB_HOST_ARCH_BITS)))
DEB_MAKE_CHECK_TARGET = runtestverbose
else
DEB_MAKE_CHECK_TARGET =
endif
DEB_MAKE_BUILD_TARGET = all DISTPKGINSTALL=$(DISTPKGINSTALL) CURRYFRONTEND=$(CURRYFRONTEND) CURRYLIBSDIR=$(CURRYLIBSDIR) CURRYTOOLSDIR=$(CURRYTOOLSDIR) PAKCSINSTALLDIR=$(PAKCSINSTALLDIR)
DEB_MAKE_CLEAN_TARGET = cleanall

DEB_DH_INSTALLCHANGELOGS_ARGS = RELNOTES.txt

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

pre-build::
	# obtain lib-trunk folder content...
	if [ ! -d "debian/build/curry-libs" ]; then \
	    mkdir -p debian/build/curry-libs/; \
	    cd debian/build/curry-libs && tar xf /usr/src/curry-libs-source.tar.xz && cd - 1>/dev/null; \
	fi

	# obtain currytools folder content...
	if [ ! -d "debian/build/curry-tools" ]; then \
	    mkdir -p debian/build/curry-tools/; \
	    cd debian/build/curry-tools && tar xf /usr/src/curry-tools-source.tar.xz && cd - 1>/dev/null; \
	fi

	# deploy Debianic pakcsinitrc into source tree...
	cp debian/pakcsinitrc .

	# make sure cleancurry is available in PAKCSHOME/bin, required for test suite
	mkdir -p bin/
	ln -fs ../scripts/cleancurry.sh bin/cleancurry

binary-post-install/pakcs::
	chmod a+x debian/pakcs/usr/lib/pakcs/bin/cleancurry
	chmod a+x debian/pakcs/usr/lib/pakcs/bin/pakcs
	chmod a+x debian/pakcs/usr/lib/pakcs/bin/pakcs-fcypp
	chmod a+x debian/pakcs/usr/lib/pakcs/bin/pakcs-makecgi
	chmod a+x debian/pakcs/usr/lib/pakcs/scripts/*.sh
	chmod a+x debian/pakcs/usr/lib/pakcs/scripts/configure-pakcs
	chmod a+x debian/pakcs/usr/lib/pakcs/scripts/makesavedstate

	chmod a-x debian/pakcs/usr/lib/pakcs/scripts/pakcsinitrc.sh

	# remove superfluous LICENSE files
	find debian/pakcs/usr/lib/pakcs/currytools/ -type f -name LICENSE -delete

clean::
	-rm -R bin/
	-rm -R currytools/
	-rm -R debian/build/
	-rm  scripts/makesavedstate

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## pakcs 2.1.0

=== Makefile ===
--- 
+++ 
@@ -47,9 +47,9 @@
 # The major version number:
 export MAJORVERSION=2
 # The minor version number:
-export MINORVERSION=0
+export MINORVERSION=1
 # The revision version number:
-REVISIONVERSION=1
+export REVISIONVERSION=0
 # The build version number (if >0, then it is a pre-release)
 BUILDVERSION=0
 # Complete version:
@@ -238,7 +238,6 @@
 .PHONY: tools
 tools:
 	@if [ -r bin/pakcs ] ; then cd currytools && $(MAKE) ; fi
-	@if [ -r bin/pakcs ] ; then cd tools      && $(MAKE) ; fi
 
 # compile analysis tool only:
 .PHONY: CASS
@@ -350,10 +349,11 @@
 cleantools: $(CLEANCURRY)
 	cd src && $(MAKE) clean
 	cd currytools && $(MAKE) uninstall
-	cd tools && $(MAKE) clean
 	cd bin && rm -f pakcs
 
 # Clean everything (including the front end)
 .PHONY: cleanall
 cleanall: clean
 	rm -rf $(LIBDIR)
+	if [ -d $(FRONTENDDIR) ]; then cd $(FRONTENDDIR) && $(MAKE) cleanall; fi
+	if [ -d $(FRONTENDDIR) ]; \

=== debian/changelog ===
pakcs (2.1.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update copyright attributions.
    + Sort listed files.
  * debian/control:
    + Bump Curry B-Ds and Ds to recent versions.
    + Bump Standards-Version: to 4.3.0. No changes needed.
  * debian/*:
    + Install documentation and example files into
      /usr/share/doc/pakcs and symlink them where needed.
  * debian/pakcs.lintian-overrides:
    + Drop file. Not required anymore.
  * debian/upstream/metadata:
    + Fix Repository-^Cowse: field.
  * debian/{rules,control}:
    + Use rdfind and symlinks to get rid of some duplicate documentation files
      (and symlink them instead).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 02 Feb 2019 15:25:32 +0100

pakcs (2.0.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Rebase 2001_run-cleancurry-from-inside-debian-subfolder.patch.
  * debian/control:
    + Bump Standards-Version. to 4.2.1. No changes needed.
    + B-D and D on latest curry-frontend, curry-libs and curry-tools.
    + Drop from D (pakcs): libjs-prototype. Not required anymore by pakcs.
  * debian/upstream/metadata:
    + Add file. Comply with DEP-12.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 23 Nov 2018 16:15:07 +0100

pakcs (2.0.1-2) unstable; urgency=medium

  * debian/control:
    + Update Vcs-*: fields. Package has been migrated to salsa.debian.org.
    + Bump Standards-Version: to 4.2.0. No changes needed.
  * debian/watch:
    + Update for tarball export feature in latest GitLab versions.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 20 Aug 2018 15:35:24 +0200

=== debian/rules ===
--- 
+++ 
@@ -69,11 +69,61 @@
 	# remove superfluous LICENSE files
 	find debian/pakcs/usr/lib/pakcs/currytools/ -type f -name LICENSE -delete
 
-clean::
-	-rm -R bin/
-	-rm -R currytools/
-	-rm -R debian/build/
-	-rm  scripts/makesavedstate
+	cd $(CURDIR)/debian/pakcs/usr/share/doc/pakcs/docs && tar --clamp-mtime --mtime="$(SOURCE_DATE)" --mode=go=rX,u+rw,a-s --sort=name -cv -v -z -f $(CURDIR)/debian/pakcs/usr/share/doc/pakcs/curry-docs.tar.gz * && cd - 1>/dev/null
+	rm -Rv debian/pakcs/usr/share/doc/pakcs/docs/
 
-get-orig-source:
-	uscan --noconf --force-download --rename --download-current-version --destdir=..
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/docs/README.txt
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/src/CPM/Repository/README.txt
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/abstract-curry/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/boxes/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass-analysis/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Demand.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Deterministic.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Functional.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Groundness.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/HiOrderConstr.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/HiOrderFunc.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/HiOrderType.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Indeterministic.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/NDEffect.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/NonDetAllDeps.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/NonDetDeps.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Overlapping.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/PatComplete.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Productive.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/README.txt
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/RequiredValue.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/RequiredValues.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Residuation.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/RightLinear.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/RootCyclic.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/RootReplaced.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/SensibleType.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/SiblingCons.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/SolComplete.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Terminating.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/Total.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/TypesInValues.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cass/docs/UnsafeModule.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/cdbi/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/csv/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/currypath/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/det-parse/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/execpath/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/finite-map/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/flatcurry/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/frontend-exec/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/json/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/opt-parse/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/profiling/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/propertyfile/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/queue/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/random/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/redblacktree/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/scc/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/socket/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/wl-pprint/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/xml/README.md

## pakcs 2.1.1

=== Makefile ===
--- 
+++ 
@@ -49,7 +49,7 @@
 # The minor version number:
 export MINORVERSION=1
 # The revision version number:
-export REVISIONVERSION=0
+export REVISIONVERSION=1
 # The build version number (if >0, then it is a pre-release)
 BUILDVERSION=0
 # Complete version:

=== debian/changelog ===
pakcs (2.1.1-2) unstable; urgency=medium

  * debian/pakcs.links:
    + Fix broken symlink from /usr/lib/pakcs/docs to the pkg's doc folder.
      (Closes: #924201).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 17 Mar 2019 21:45:24 +0100

pakcs (2.1.1-1) unstable; urgency=medium

  * New upstream release.
    - Fix loading for external Prolog files. (Closes: #922024).
  * debian/pakcs.links:
    + Typo fix in link target path.
  * debian/rules:
    + Patch $(CURRYTOOLSDIR)/cpm/Makefile and fix installation path of the
      cpm template files.
    + Unset PAKCSBUILDDIR variables wherever used. Hide the build path of the
      pakcs DEB package.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 20 Feb 2019 15:35:00 +0100

=== debian/control ===
--- 
+++ 
@@ -8,24 +8,25 @@
 Build-Depends: cdbs,
  debhelper (>= 10~),
  quilt,
- curry-frontend (>= 1.0.1~),
- curry-libs-source (>= 2.0.1~),
- curry-tools-source (>= 2.0.1~),
+ curry-frontend (>= 1.0.3~),
+ curry-libs-source (>= 2.1.0~),
+ curry-tools-source (>= 2.1.0~),
  swi-prolog-nox (>= 7.4),
  sqlite3,
  lockfile-progs,
-Standards-Version: 4.1.3
+ rdfind,
+ symlinks,
+Standards-Version: 4.3.0
 Homepage: https://www-ps.informatik.uni-kiel.de/~pakcs/
-Vcs-Browser: https://anonscm.debian.org/git/pkg-curry/pakcs.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-curry/pakcs.git
+Vcs-Browser: https://salsa.debian.org/pkg-curry-team/pakcs
+Vcs-Git: https://salsa.debian.org/pkg-curry-team/pakcs.git
 
 Package: pakcs
 Architecture: any
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
- curry-frontend (>= 1.0.1~),
- libjs-prototype (>= 1.6),
+ curry-frontend (>= 1.0.3~),
  swi-prolog-nox (>= 7.4),
  lockfile-progs,
 Recommends:

=== debian/rules ===
--- 
+++ 
@@ -48,6 +48,8 @@
 	    cd debian/build/curry-tools && tar xf /usr/src/curry-tools-source.tar.xz && cd - 1>/dev/null; \
 	fi
 
+	sed -i "$(CURRYTOOLSDIR)/cpm/Makefile" -e "s@packagePath\ =\ .*\"@packagePath\ =\ \\\\\"/usr/lib/pakcs/currytools/cpm\\\\\"\"@"
+
 	# deploy Debianic pakcsinitrc into source tree...
 	cp debian/pakcsinitrc .
 
@@ -63,6 +65,16 @@
 	chmod a+x debian/pakcs/usr/lib/pakcs/scripts/*.sh
 	chmod a+x debian/pakcs/usr/lib/pakcs/scripts/configure-pakcs
 	chmod a+x debian/pakcs/usr/lib/pakcs/scripts/makesavedstate
+
+	# unset PAKCSBUILDDIR, only support PAKCSINSTALLDIR
+	for script in  debian/pakcs/usr/lib/pakcs/bin/pakcs debian/pakcs/usr/lib/pakcs/bin/pakcs-fcypp debian/pakcs/usr/lib/pakcs/bin/pakcs-makecgi; do \
+		sed -i "$$script" -e "s|^PAKCSBUILDDIR=.*$$|PAKCSBUILDDIR=\"<unset>\"|"; \
+	done
+
+	# similarly for buildDir Prolog variable
+	for script in debian/pakcs/usr/lib/pakcs/src/pakcsversion.pl; do \
+		sed -i "$$script" -e "s|buildDir('.*')|buildDir('<unset>')|g"; \
+	done
 
 	chmod a-x debian/pakcs/usr/lib/pakcs/scripts/pakcsinitrc.sh
 
@@ -121,9 +133,3 @@
 	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/profiling/README.md
 	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/propertyfile/README.md
 	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/queue/README.md
-	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/random/README.md
-	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/redblacktree/README.md
-	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/scc/README.md
-	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/socket/README.md
-	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/wl-pprint/README.md
-	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/xml/README.md

## pakcs 2.2.0

=== Makefile ===
--- 
+++ 
@@ -47,9 +47,9 @@
 # The major version number:
 export MAJORVERSION=2
 # The minor version number:
-export MINORVERSION=1
+export MINORVERSION=2
 # The revision version number:
-export REVISIONVERSION=1
+export REVISIONVERSION=0
 # The build version number (if >0, then it is a pre-release)
 BUILDVERSION=0
 # Complete version:
@@ -170,7 +170,8 @@
 	$(MAKE) $(PAKCSVERSION)
 	cd src && $(MAKE)
 	# compile all libraries:
-	@cd lib && $(MAKE) acy
+	@cd lib && $(MAKE) AllLibraries.curry
+	scripts/compile-all-libs.sh
 	# compile optimization tools:
 	@cd currytools/optimize && $(MAKE)
 	# prepare for separate compilation: compile all libraries to Prolog
@@ -355,5 +356,3 @@
 .PHONY: cleanall
 cleanall: clean
 	rm -rf $(LIBDIR)
-	if [ -d $(FRONTENDDIR) ]; then cd $(FRONTENDDIR) && $(MAKE) cleanall; fi
-	if [ -d $(FRONTENDDIR) ]; \

=== frontend/Makefile ===
--- 
+++ 
@@ -73,7 +73,9 @@
 	mkdir -p $(@D)
 	cd curry-base     && $(CABAL_INSTALL)
 	$(MAKE) transformers # see below
-	cd curry-frontend && $(CABAL_INSTALL) --bindir=$(@D)
+	# Option --force-reinstalls necessary due to problems with package
+	# HTTP-*
+	cd curry-frontend && $(CABAL_INSTALL) --force-reinstalls --bindir=$(@D)
 
 # Temporary workaround for https://github.com/haskell/cabal/issues/1855
 # see also http://www.haskell.org/pipermail/cabal-devel/2014-May/009795.html

=== src/Makefile ===
--- 
+++ 
@@ -13,8 +13,15 @@
 # The SWI-Prolog interpreter:
 SWI=$(BINDIR)/swiprolog
 
-# Standard options for SWI-Prolog
-SWIOPTIONS=-q -L0 -G0 -T0 -O
+# Standard options for SWI-Prolog: quiet and optimized compilation
+SWIOPTIONS=-q -O
+# If there is a local stack overflow during compilation (e.g., reported
+# by a message like "ERROR: local"), one should increase the stack sizes
+# by redefining this definition according to version of SWI-Prolog:
+# SWI-Prolog 7.*: use 2GB for the local stack:
+#SWIOPTIONS=-q -L2G -G0 -T0 -O
+# SWI-Prolog 8.*: use 4GB for all stacks:
+#SWIOPTIONS=-q --stack_limit=4g -O
 
 # library directory of PAKCS:
 ifndef LIBDIR

=== docs/src/Makefile ===
--- 
+++ 
@@ -17,8 +17,6 @@
 	pdflatex manual
 
 ../Manual.pdf: manual.pdf
-	thumbpdf manual
-	pdflatex manual
 	rm -f $@
 	cp $< $@

=== debian/changelog ===
pakcs (2.2.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump versioned B-Ds and Ds for PAKCS 2.2.0.
    + Bump Standards-Version: to 4.4.1. No changes needed.
  * debian/move2docs_and_symlink.sh:
    + Fail on errors.
  * debian/rules:
    + Update move2docs command list (for tools/cpm/Implementation.md and
      tools/optimize/README.txt -> README.md).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 14 Jan 2020 07:35:43 +0100

=== debian/control ===
--- 
+++ 
@@ -8,15 +8,15 @@
 Build-Depends: cdbs,
  debhelper (>= 10~),
  quilt,
- curry-frontend (>= 1.0.3~),
- curry-libs-source (>= 2.1.0~),
- curry-tools-source (>= 2.1.0~),
+ curry-frontend (>= 1.0.4-3~),
+ curry-libs-source (>= 2.2.0~),
+ curry-tools-source (>= 2.2.0~),
  swi-prolog-nox (>= 7.4),
  sqlite3,
  lockfile-progs,
  rdfind,
  symlinks,
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Homepage: https://www-ps.informatik.uni-kiel.de/~pakcs/
 Vcs-Browser: https://salsa.debian.org/pkg-curry-team/pakcs
 Vcs-Git: https://salsa.debian.org/pkg-curry-team/pakcs.git
@@ -26,7 +26,7 @@
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
- curry-frontend (>= 1.0.3~),
+ curry-frontend (>= 1.0.4-3~),
  swi-prolog-nox (>= 7.4),
  lockfile-progs,
 Recommends:

=== debian/rules ===
--- 
+++ 
@@ -85,6 +85,7 @@
 	rm -Rv debian/pakcs/usr/share/doc/pakcs/docs/
 
 	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/README.md
+	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/Implementation.md
 	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/README.md
 	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/docs/README.txt
 	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/src/CPM/Repository/README.txt
@@ -132,4 +133,3 @@
 	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/opt-parse/README.md
 	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/profiling/README.md
 	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/propertyfile/README.md
-	debian/move2docs_and_symlink.sh usr/lib/pakcs/currytools/cpm/vendor/queue/README.md

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg[0-9]*//,filenamemangle=s/.*\/pakcs-v(\d\S+)\.tar\.gz/pakcs-$1\.tar\.gz/g \
  https://git.ps.informatik.uni-kiel.de/curry/pakcs/tags?sort=updated_desc .*/archive/v?(\d\S+)\/.*.tar\.gz
